##### Umwandlung der Antenna Pattern Files von EZNEC in ein #####
##### VOACAP Antenna File vom
##### 1) Typ 11 = Azimuthal symmetrisches, tabellarisches   #####
##### 2) Typ 13 = Tabellarisches Format                     #####
#####
##### Das EZNEC File muss als "Elevation slices"
##### mit 1 Grad als Inkrement
##### gespeichert werden.


Type = 13
Grad = 180  # Nur Typ 11: Winkel zwischen EZNEC X-Achse und Gegenantenne (Uhrzeigersinn)


setwd("H:/DIVERSES/Amateurfunk/Antennen/VOACAP")
frequency = read.table("Elevation slices.txt", header = FALSE, dec=",", skip=6, nrows=1)
data = read.table("Elevation slices.txt", header = FALSE, dec=",", skip=10, fill=TRUE)
frequency = frequency[1,3]
TotdB = as.numeric(sub(",",".",data$V4))

if (Type == 11) {
##### Type 11 File erzeugen
za = 183*(360-Grad)%%360+3
ze = 183*(360-Grad)%%360+93
db = TotdB[za:ze]
db=format(db,nsmall=2)
write("EZNEC: type 11 gain table versus Elevation Angle", file="EZNEC_11.ant")
write(" 3     3 parameters", file="EZNEC_11.ant", append = TRUE)
write("  0.00  [ 1] Max Gain dBi..:", file="EZNEC_11.ant", append = TRUE)
write("  11    [ 2] Antenna Type..: 91 values gain in elevation angle follows", file="EZNEC_11.ant", append = TRUE)
write("  0.0   [ 3] Efficiency (for IONCAP)", file="EZNEC_11.ant", append = TRUE)
write(db, file="EZNEC_11.ant", ncolumns = 10, append = TRUE)
}


if (Type == 13) {
##### Type 13 File erzeugen
write("EZNEC: type 13  360 degree gain table", file="EZNEC_13.ant")
write(" 4     4 parameters", file="EZNEC_13.ant", append = TRUE)
write("  0.00  [ 1] Max Gain dBi..:", file="EZNEC_13.ant", append = TRUE)
write("  13    [ 2] Antenna Type..: 360 * 91 gain values follow", file="EZNEC_13.ant", append = TRUE)
write("  0.0   [ 3] Efficiency (for IONCAP)", file="EZNEC_13.ant", append = TRUE)
write(paste(frequency,"  [ 4] Frequency"), file="EZNEC_13.ant", append = TRUE)
for (Grad in 0:359){
  za = 183*(360-Grad)%%360 + 3
  ze = 183*(360-Grad)%%360 + 12
  db = TotdB[za:ze]
  db=formatC(db,digits=2,width=6,format="f",flag="#")
  b=paste(" ",Grad)
  if (Grad < 100) {
   b=paste("",b)}
  if (Grad < 10) {
   b=paste("",b)}
  b=paste(b,"  ",db[1],db[2],db[3],db[4],db[5],db[6],db[7],db[8],db[9],db[10])
  write(b, file="EZNEC_13.ant", append = TRUE)
  for (Zeile in 2:9){
    za = 183*(360-Grad)%%360 + (Zeile-1)*10 + 3
    ze = 183*(360-Grad)%%360 + (Zeile-1)*10 + 12
    db = TotdB[za:ze]
    db=formatC(db,digits=2,width=6,format="f",flag="#")
    b=paste("        ",db[1],db[2],db[3],db[4],db[5],db[6],db[7],db[8],db[9],db[10])
    write(b, file="EZNEC_13.ant", append = TRUE)
    }
  za = 183*(360-Grad)%%360 + (10-1)*10 + 3
  db = TotdB[za]
  db=formatC(db,digits=2,width=6,format="f",flag="#")
  b=paste("        ",db[1])
  write(b, file="EZNEC_13.ant", append = TRUE)
  }
}